import torch
import torchvision
import torchvision.transforms as transforms
import torch.utils.data as data

#Preprocess
transform = transforms.Compose(
    [transforms.ToTensor(),
     transforms.Normalize((0.5, 0.5, 0.5), (0.5, 0.5, 0.5))])

#Train
trainset = torchvision.datasets.CIFAR10(root='./data', train=True,
                                        download=True, transform=transform)
trainloader = data.DataLoader(trainset, batch_size=4,
                                          shuffle=True, num_workers=2)
#Test
testset = torchvision.datasets.CIFAR10(root='./data', train=False,
                                       download=True, transform=transform)
testloader = data.DataLoader(testset, batch_size=4,
                                         shuffle=False, num_workers=2)

# CNN modules and primitives
import torch.nn as nn
import torch.nn.functional as F

class LeNet(nn.Module):
    def __init__(self):
        super(LeNet, self).__init__()
        self.conv1 = nn.Conv2d(3, 6, 5)
        self.pool = nn.MaxPool2d(2, 2)
        self.conv2 = nn.Conv2d(6, 16, 5)
        self.fc1 = nn.Linear(16 * 5 * 5, 120)
        self.fc2 = nn.Linear(120, 84)
        self.fc3 = nn.Linear(84, 10)
    def forward(self, x):
        x = self.pool(F.relu(self.conv1(x)))
        x = self.pool(F.relu(self.conv2(x)))
        x = x.view(-1, 16 * 5 * 5)
        x = F.relu(self.fc1(x))
        x = F.relu(self.fc2(x))
        x = self.fc3(x)
        return x

net = LeNet()
net = net.cuda() # GPU!!!

import torch.optim as optim
criterion = nn.CrossEntropyLoss()
optimizer = optim.SGD(net.parameters(), lr=0.001, momentum=0.9)

def adjust_learning_rate(optimizer, epoch):
    scale = 0.33
    step  = 10
    lr = 0.001 * (scale ** (epoch // step))
    print('lr: {}'.format(lr))
    if (epoch != 0) & (epoch % step == 0):
        print('Change lr')
        for param_group in optimizer.param_groups:
            param_group['lr'] = param_group['lr'] * scale

for epoch in range(2):  
        adjust_learning_rate(optimizer, epoch)
	for i,data in enumerate(trainloader, 0):
 	     inputs,labels = data
	     inputs = inputs.cuda()
             labels = labels.cuda()
	     optimizer.zero_grad()
	     outputs = net(inputs)
	     loss = criterion(outputs, labels)
	     loss.backward()	
	     optimizer.step()
	     print loss.item()


